'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _debounce2 = require('lodash/debounce');var _debounce3 = _interopRequireDefault(_debounce2);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _Btn = require('../Btn');var _Btn2 = _interopRequireDefault(_Btn);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

// prettier-ignore
var INPUT_PROPS = [
'name', 'disabled', 'min', 'max', 'placeholder', 'autoFocus', 'tabIndex', 'readOnly'];


/**
                                                                                        * @class FormFieldNumber
                                                                                        * @augments {Component<{
                                                                                             [x:string]: any
                                                                                             className?: string
                                                                                             debounce?: number
                                                                                             disabled?: boolean
                                                                                             id?: string
                                                                                             label?
                                                                                             max?: string | number
                                                                                             min?: string | number
                                                                                             name?: string
                                                                                             readOnly?: boolean
                                                                                             size?: string | number
                                                                                             style?: Object
                                                                                             touched?: boolean
                                                                                             value?: number
                                                                                             onBlur?: Function
                                                                                             onChange?: Function
                                                                                             onFocus?: Function
                                                                                             validation?: Function
                                                                                           }, any>}
                                                                                        */var
FormFieldNumber = function (_Component) {_inherits(FormFieldNumber, _Component);function FormFieldNumber() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldNumber);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldNumber.__proto__ || Object.getPrototypeOf(FormFieldNumber)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldNumber, [{ key: 'componentWillMount', value: function componentWillMount()









































    {
      this.setPropsToState(this.props);
    } }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(

    nextProps) {
      this.setPropsToState(nextProps);
    }







































    // eslint-disable-next-line complexity














































    /*
     * @public
     */ }, { key: 'render', value: function render()








    {var _this2 = this;var _props =








      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,readOnly = _props.readOnly,size = _props.size,step = _props.step;var _state =
      this.state,id = _state.id,val = _state.val,error = _state.error,focused = _state.focused;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';
      return (
        _react2.default.createElement('div', { className: 'FormField FormField--number ' + className, style: style },
          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className: 'FormField-control',
              type: 'number',
              pattern: '[\\d.-]*',
              style: { width: 'calc(' + size + 'ch + 2em)' },
              autoComplete: 'off',
              value: val },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: this.handleChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            !disabled &&
            !readOnly &&
            _react2.default.createElement(_Btn2.default, {
              tagName: 'span',
              className: 'FormField-spin FormField-spin--plus',
              disabled: disabled,
              onClick: function onClick(ev) {return (
                  _this2.handleChange(ev, _this2.preciseSum(val, step)));} }),



            !disabled &&
            !readOnly &&
            _react2.default.createElement(_Btn2.default, {
              tagName: 'span',
              className: 'FormField-spin FormField-spin--minus',
              disabled: disabled,
              onClick: function onClick(ev) {return (
                  _this2.handleChange(ev, _this2.preciseSum(val, -step)));} }),



            error && _react2.default.createElement('p', { className: 'FormField-error' }, error))));



    } }]);return FormFieldNumber;}(_react.Component);FormFieldNumber.propTypes = { className: _propTypes2.default.string, debounce: _propTypes2.default.number, decimals: _propTypes2.default.number, disabled: _propTypes2.default.bool, id: _propTypes2.default.string, label: _propTypes2.default.node, max: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), min: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), step: _propTypes2.default.number, style: _propTypes2.default.object, touched: _propTypes2.default.bool, value: _propTypes2.default.number, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func, validation: _propTypes2.default.func };FormFieldNumber.defaultProps = { className: '', decimals: 0, debounce: 200, size: 100, step: 1, value: 0, onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {}, validation: function validation() {} };var _initialiseProps = function _initialiseProps() {var _this3 = this;this.state = { error: null, focused: false, touched: false };this.setPropsToState = function (props) {var val = Number(props.value);_this3.setState(function (_ref2) {var touched = _ref2.touched;return _extends({ val: val, id: props.id || props.name && 'ff-number-' + props.name }, props.touched ? { touched: true } : {});}, function () {if (_this3.state.touched) {_this3.validate();}});};this.clamp = function (val) {var _props2 = _this3.props,min = _props2.min,max = _props2.max,decimals = _props2.decimals;val = Number(val.toFixed(decimals));if (typeof min !== 'undefined' && val < min) {val = Number(min);}if (typeof max !== 'undefined' && val > max) {val = Number(max);}return val;};this.preciseSum = function (val1, val2) {var decimals = Math.max(0, Number((String(val1).split('.')[1] || '').length), Number((String(val2).split('.')[1] || '').length));decimals = Math.min(decimals, _this3.props.decimals);return Number((val1 + val2).toFixed(decimals));};this.handleChange = function (ev, val) {var _state2 = _this3.state,error = _state2.error,focused = _state2.focused;var isValProvided = typeof val === 'number';var target = ev.target;if (isValProvided) {val = _this3.clamp(val);} else {if (target.value === '') {window.requestAnimationFrame(function () {return target.value = '';});return;}val = Number(target.value.replace(/[^\d.-]/g, ''));}_this3.setState(_extends({ val: val }, isValProvided ? { touched: true } : {}, !focused || error && focused ? _this3.validate(val, false) : {}));_this3.triggerOnChange(val);};this.handleFocus = function (ev) {_this3.setState({ focused: true });_this3.props.onFocus(ev);};this.handleBlur = function (ev) {var val = _this3.state.val;var clamped = _this3.clamp(val);if (clamped !== val) {_this3.triggerOnChange(clamped);}_this3.setState(_extends({ focused: false, touched: true, val: clamped }, _this3.validate(clamped, false)));_this3.props.onBlur(ev);};this.triggerOnChange = (0, _debounce3.default)(function () {var _props3;(_props3 = _this3.props).onChange.apply(_props3, arguments); // call the fresh prop
  }, this.props.debounce);this.validate = function () {var val = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this3.state.val;var updateState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;var error = _this3.props.validation(val) || null;if (updateState && error !== _this3.state.error) {_this3.setState({ error: error });}return { error: error };};};exports.default =

FormFieldNumber;