'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _debounce2 = require('lodash/debounce');var _debounce3 = _interopRequireDefault(_debounce2);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _Btn = require('../Btn');var _Btn2 = _interopRequireDefault(_Btn);
var _Icon = require('../Icon');var _Icon2 = _interopRequireDefault(_Icon);
var _Dropdown = require('../Dropdown');var _Dropdown2 = _interopRequireDefault(_Dropdown);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}function _toConsumableArray(arr) {if (Array.isArray(arr)) {for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {arr2[i] = arr[i];}return arr2;} else {return Array.from(arr);}}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

// prettier-ignore
var INPUT_PROPS = [
'name', 'disabled', 'placeholder', 'autoFocus', 'tabIndex', 'readOnly'];


/**
                                                                          * @class FormFieldSuggest
                                                                          * @augments {Component<{
                                                                               [x:string]: any
                                                                               allowAny?: boolean
                                                                               className?: string
                                                                               debounceLoad?: number
                                                                               disabled?: boolean
                                                                               id?: string
                                                                               label?
                                                                               labelKey?: string
                                                                               name?: string
                                                                               noInputText?: string
                                                                               noOptionsText?: string
                                                                               options?: Array<Object>
                                                                               placeholder?: string
                                                                               readOnly?: boolean
                                                                               rows?: string | number
                                                                               size?: string | number
                                                                               style?: Object
                                                                               touched?: boolean
                                                                               value?: Object
                                                                               valueKey?: string
                                                                               filterOptions?: Function
                                                                               loadOptions?: Function
                                                                               onBlur?: Function
                                                                               onChange?: Function
                                                                               onFocus?: Function
                                                                               optionRenderer?: Function
                                                                               validation?: Function
                                                                             }, any>}
                                                                          */var
FormFieldSuggest = function (_Component) {_inherits(FormFieldSuggest, _Component);function FormFieldSuggest() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldSuggest);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldSuggest.__proto__ || Object.getPrototypeOf(FormFieldSuggest)).call.apply(_ref, [this].concat(args))), _this), _this.

















































    state = {
      cache: {},
      changed: false,
      error: null,
      focused: false,
      input: '',
      isLoading: false,
      touched: false,
      kbdFocusIdx: -1 }, _this.










    setPropsToState = function (props) {
      var val = props.value;
      var opts = [].concat(_toConsumableArray(props.options));
      _this.setState(
      function (_ref2) {var touched = _ref2.touched,prevVal = _ref2.val;return _extends({
          val: val,
          opts: opts,
          id: props.id || props.name && 'ff-suggest-' + props.name },
        prevVal !== props.value ? { input: '' } : {},
        props.touched ? { touched: true } : {});},

      function () {
        if (_this.state.touched) {
          _this.validate();
        }
      });

    }, _this.

    getAsyncOptions = (0, _debounce3.default)(function (input) {
      return _this.props.
      loadOptions(input).
      then(function (options) {
        if (_this.controlEl) {
          _this.setState(function (prevState) {return {
              cache: _extends({}, prevState.cache, _defineProperty({}, input, options)),
              isLoading: prevState.input === input ? false : prevState.isLoading,
              opts: options };});

        }
      }).
      catch(function () {
        if (_this.controlEl && _this.state.input === input) {
          _this.setState({ isLoading: false, opts: [] });
        }
      });
    }, _this.props.debounceLoad), _this.

    handleInputChange = function (ev) {var _this$props =
      _this.props,options = _this$props.options,filterOptions = _this$props.filterOptions;var _this$state =
      _this.state,cache = _this$state.cache,val = _this$state.val;
      var input = ev.target.value;

      _this.setState({ input: input, kbdFocusIdx: -1 });
      if (_this.props.loadOptions && !cache[input]) {
        _this.setState({ isLoading: true });
        _this.getAsyncOptions(input);
      }
      if (!_this.props.loadOptions) {
        _this.setState({ opts: filterOptions([].concat(_toConsumableArray(options)), input, val) });
      }
    }, _this.

    handleSelect = function (option) {var _this$props2 =
      _this.props,labelKey = _this$props2.labelKey,valueKey = _this$props2.valueKey;

      if (!option) {
        option = null;
      }
      if (typeof option === 'string') {var _option;
        option = (_option = {}, _defineProperty(_option, labelKey, option), _defineProperty(_option, valueKey, option), _defineProperty(_option, 'isNewOption', true), _option);
      }

      _this.setState({ val: option, changed: true });
      _this.controlEl.blur(); // trigger field blur
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      clearTimeout(_this.blurTimeout);
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {
      ev.persist();
      // wait click
      _this.blurTimeout = setTimeout(function () {var _this$state2 =
        _this.state,val = _this$state2.val,changed = _this$state2.changed;
        if (_this.controlEl) {
          // still mounted
          _this.setState(_extends({
            focused: false,
            touched: true,
            changed: false,
            kbdFocusIdx: -1 },
          !val ? { input: '', opts: _this.props.options } : {},
          _this.validate(val, false)));

        }

        if (changed) {
          _this.props.onChange(val);
        }
        _this.props.onBlur(ev);
      }, 320);
    }, _this.


    handleKeyDown = function (ev) {var _this$props3 =
      _this.props,valueKey = _this$props3.valueKey,allowAny = _this$props3.allowAny;var _this$state3 =
      _this.state,val = _this$state3.val,input = _this$state3.input,kbdFocusIdx = _this$state3.kbdFocusIdx,opts = _this$state3.opts;
      switch (ev.keyCode) {
        case 13: // enter
          ev.preventDefault(); // don't submit the form
          if (opts[kbdFocusIdx]) {
            _this.handleSelect(opts[kbdFocusIdx]);
          } else if (allowAny) {
            _this.handleSelect(input);
          }
          break;
        case 8: // backspace
        case 46: // canc
          if (val) {
            _this.setState({ val: null, changed: true });
          }
          break;
        case 38: // up
        case 40: // down
          kbdFocusIdx += ev.keyCode === 38 ? -1 : 1;
          kbdFocusIdx = Math.max(0, Math.min(kbdFocusIdx, opts.length - 1));
          _this.setState({ kbdFocusIdx: kbdFocusIdx });
          ev.preventDefault();
          break;
        default:
          if (val && val.isNewOption) {
            _this.setState({ val: null, input: val[valueKey], changed: true });
          }
          if (val && !val.isNewOption) {
            ev.preventDefault();
          }}

    }, _this.

    validate = function () {var val = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.val;var updateState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var error = _this.props.validation(val) || null;
      if (updateState && error !== _this.state.error) {
        _this.setState({ error: error });
      }
      return { error: error };
    }, _this.

    kbdScrollIntoView = function (el) {
      var parent = el.parentNode;
      var eDim = el.getBoundingClientRect();
      var pDim = parent.getBoundingClientRect();
      var startY = parent.scrollTop;
      var endY = startY;
      var offsetY = startY + eDim.top - pDim.top;
      var topEdge = offsetY - 20;
      var bottomEdge = offsetY + eDim.height - pDim.height + 20;

      if (topEdge < startY) {
        endY = topEdge;
      }
      if (bottomEdge > startY) {
        endY = bottomEdge;
      }
      parent.scrollTop = endY;
    }, _this.

    renderOverlay = function () {var _this$props4 =
      _this.props,loadOptions = _this$props4.loadOptions,rows = _this$props4.rows,noInputText = _this$props4.noInputText;var _this$state4 =
      _this.state,isLoading = _this$state4.isLoading,input = _this$state4.input;
      return (
        _react2.default.createElement(_Dropdown2.default, {
            className: 'Dropdown--cover Dropdown--field',
            align: 'left',
            opened: true,
            modal: false },

          _react2.default.createElement('ul', {
              className: 'FormField-options',
              style: { maxHeight: Number(rows) * 2.26 + 'rem' } },

            loadOptions && (isLoading || !input) ?
            _react2.default.createElement('li', { className: 'FormField-noOptions' },
              isLoading ? _react2.default.createElement(_Icon2.default, { glyph: 'loading' }) : noInputText) :


            _this.renderOptions())));




    }, _this.

    renderOptions = function () {var _this$props5 =
      _this.props,valueKey = _this$props5.valueKey,labelKey = _this$props5.labelKey,optionRenderer = _this$props5.optionRenderer,noOptionsText = _this$props5.noOptionsText;var _this$state5 =
      _this.state,opts = _this$state5.opts,val = _this$state5.val,kbdFocusIdx = _this$state5.kbdFocusIdx;

      if (!opts.length) {
        return _react2.default.createElement('li', { className: 'FormField-noOptions' }, noOptionsText);
      }

      return opts.map(function (opt, i) {return (
          _react2.default.createElement('li', {
              key: opt[valueKey],
              ref: function ref(c) {return c && kbdFocusIdx === i && _this.kbdScrollIntoView(c);},
              className:
              'FormField-option ' + (
              val && val[valueKey] === opt[valueKey] ? ' isSelected' : '') + (
              opt.isNewOption ? ' isNew' : '') + (
              kbdFocusIdx === i ? ' isFocused' : ''),

              onClick: function onClick() {return _this.handleSelect(opt);} },

            optionRenderer ?
            optionRenderer(opt) :

            _react2.default.createElement(_Btn2.default, {
                className: 'Btn--plain Btn--line',
                'aria-selected': kbdFocusIdx === i },

              opt[labelKey])));});




    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldSuggest, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} // eslint-disable-next-line complexity
  }, { key: 'render',
    // eslint-disable-next-line complexity
    value: function render() {var _this2 = this;var _props =









      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,readOnly = _props.readOnly,size = _props.size,labelKey = _props.labelKey,allowAny = _props.allowAny;var _state =
      this.state,id = _state.id,val = _state.val,error = _state.error,focused = _state.focused,input = _state.input;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';
      return (
        _react2.default.createElement('div', {
            className: 'FormField FormField--suggest ' + className,
            style: style },

          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className:
              'FormField-control' + (
              allowAny && input ? ' FormField-control--iconR' : ''),

              ref: function ref(c) {return _this2.controlEl = c;},
              style: { width: 'calc(' + size + 'ch + 2em)' },
              type: 'text',
              value: val ? val[labelKey] : input },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              autoComplete: 'off',
              onKeyDown: this.handleKeyDown,
              onChange: this.handleInputChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),


            focused && !readOnly && this.renderOverlay(),

            focused &&
            !readOnly &&
            allowAny &&
            input &&
            _react2.default.createElement('span', { className: 'FormField-selectNew' },
              _react2.default.createElement(_Btn2.default, {
                  className: 'Btn--square',
                  onClick: function onClick() {return _this2.handleSelect(_this2.state.input);} },

                _react2.default.createElement(_Icon2.default, { glyph: 'check' }))),




            error && _react2.default.createElement('p', { className: 'FormField-error' }, error))));



    } }]);return FormFieldSuggest;}(_react.Component);FormFieldSuggest.propTypes = { allowAny: _propTypes2.default.bool, className: _propTypes2.default.string, debounceLoad: _propTypes2.default.number, disabled: _propTypes2.default.bool, id: _propTypes2.default.string, label: _propTypes2.default.node, labelKey: _propTypes2.default.string, name: _propTypes2.default.string, noInputText: _propTypes2.default.string, noOptionsText: _propTypes2.default.string, options: _propTypes2.default.arrayOf(_propTypes2.default.object), placeholder: _propTypes2.default.string, readOnly: _propTypes2.default.bool, rows: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), style: _propTypes2.default.object, touched: _propTypes2.default.bool, value: _propTypes2.default.object, valueKey: _propTypes2.default.string, filterOptions: _propTypes2.default.func, loadOptions: _propTypes2.default.func, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func, optionRenderer: _propTypes2.default.func, validation: _propTypes2.default.func };FormFieldSuggest.defaultProps = { className: '', debounceLoad: 1000, labelKey: 'label', noInputText: 'Start typing to search', noOptionsText: 'No results found', options: [], rows: 7.5, size: 100, value: null, valueKey: 'value', filterOptions: function filterOptions(options, input, selected) {return options;}, loadOptions: null, onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {}, optionRenderer: null, validation: function validation() {} };exports.default =


FormFieldSuggest;