'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _debounce2 = require('lodash/debounce');var _debounce3 = _interopRequireDefault(_debounce2);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

// prettier-ignore
var INPUT_PROPS = [
'name', 'disabled', 'placeholder', 'tabIndex', 'readOnly',
'autoCorrect', 'autoFocus', 'spellCheck'];


/**
                                            * @class FormFieldTextarea
                                            * @augments {Component<{
                                                 [x:string]: any
                                                 className?: string
                                                 cols?: string | number
                                                 debounce?: number
                                                 disabled?: boolean
                                                 id?: string
                                                 label?
                                                 name?: string
                                                 readOnly?: boolean
                                                 rows?: string | number
                                                 style?: Object
                                                 touched?: boolean
                                                 value?: string
                                                 onBlur?: Function
                                                 onChange?: Function
                                                 onFocus?: Function
                                                 validation?: Function
                                               }, any>}
                                            */var
FormFieldTextarea = function (_Component) {_inherits(FormFieldTextarea, _Component);function FormFieldTextarea() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldTextarea);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldTextarea.__proto__ || Object.getPrototypeOf(FormFieldTextarea)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldTextarea, [{ key: 'componentWillMount', value: function componentWillMount()





































    {
      this.setPropsToState(this.props);
    } }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(

    nextProps) {
      this.setPropsToState(nextProps);
    }














































    /*
       * @public
       */ }, { key: 'render', value: function render()








    {var _props =








      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,readOnly = _props.readOnly,cols = _props.cols,rows = _props.rows;var _state =
      this.state,id = _state.id,val = _state.val,error = _state.error,focused = _state.focused;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';
      return (
        _react2.default.createElement('div', {
            className: 'FormField FormField--textarea ' + className,
            style: style },

          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('textarea', _extends({
              id: id,
              className: 'FormField-control',
              style: {
                width: 'calc(' + cols + 'ch + 2em)',
                height: Number(rows) * 1.6 + 'em' },

              value: val },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: this.handleChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            error && _react2.default.createElement('p', { className: 'FormField-error' }, error))));



    } }]);return FormFieldTextarea;}(_react.Component);FormFieldTextarea.propTypes = { className: _propTypes2.default.string, cols: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), debounce: _propTypes2.default.number, disabled: _propTypes2.default.bool, id: _propTypes2.default.string, label: _propTypes2.default.node, name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, rows: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), style: _propTypes2.default.object, touched: _propTypes2.default.bool, value: _propTypes2.default.string, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func, validation: _propTypes2.default.func };FormFieldTextarea.defaultProps = { className: '', cols: 100, debounce: 200, value: '', rows: 3, onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {}, validation: function validation() {} };var _initialiseProps = function _initialiseProps() {var _this2 = this;this.state = { error: null, focused: false, touched: false };this.setPropsToState = function (props) {var val = props.value;_this2.setState(function (_ref2) {var touched = _ref2.touched;return _extends({ val: val, id: props.id || props.name && 'ff-textarea-' + props.name }, props.touched ? { touched: true } : {});}, function () {if (_this2.state.touched) {_this2.validate();}});};this.handleChange = function (ev) {var _state2 = _this2.state,error = _state2.error,focused = _state2.focused;var val = ev.target.value;_this2.setState(_extends({ val: val }, error && focused ? _this2.validate(val, false) : {}));_this2.triggerOnChange(val);};this.handleFocus = function (ev) {_this2.setState({ focused: true });_this2.props.onFocus(ev);};this.handleBlur = function (ev) {_this2.setState(function (_ref3) {var val = _ref3.val;return _extends({ focused: false, touched: true }, _this2.validate(val, false));});_this2.props.onBlur(ev);};this.triggerOnChange = (0, _debounce3.default)(function () {var _props2;(_props2 = _this2.props).onChange.apply(_props2, arguments); // call the fresh prop
  }, this.props.debounce);this.validate = function () {var val = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this2.state.val;var updateState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;var error = _this2.props.validation(val) || null;if (updateState && error !== _this2.state.error) {_this2.setState({ error: error });}return { error: error };};};exports.default =

FormFieldTextarea;