'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _debounce2 = require('lodash/debounce');var _debounce3 = _interopRequireDefault(_debounce2);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _Icon = require('../Icon');var _Icon2 = _interopRequireDefault(_Icon);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

var INPUT_PROPS = ['name', 'disabled', 'tabIndex', 'type'];

/**
                                                             * @class FormFieldTick
                                                             * @augments {Component<{
                                                                  [x:string]: any
                                                                  checked?: boolean
                                                                  className?: string
                                                                  debounce?: number
                                                                  disabled?: boolean
                                                                  id?: string
                                                                  label?
                                                                  name?: string
                                                                  readOnly?: boolean
                                                                  style?: any
                                                                  touched?: boolean
                                                                  type?: 'radio' | 'checkbox'
                                                                  value?: string
                                                                  onBlur?: Function
                                                                  onChange?: Function
                                                                  onFocus?: Function
                                                                  validation?: Function
                                                                }, any>}
                                                             */var
FormFieldTick = function (_Component) {_inherits(FormFieldTick, _Component);function FormFieldTick() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldTick);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldTick.__proto__ || Object.getPrototypeOf(FormFieldTick)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldTick, [{ key: 'componentWillMount', value: function componentWillMount()




































    {
      this.setPropsToState(this.props);
    } }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(

    nextProps) {
      this.setPropsToState(nextProps);
    }












































    /*
       * @public
       */ }, { key: 'render',








    // eslint-disable-next-line complexity
    value: function render() {var _props =








      this.props,className = _props.className,style = _props.style,label = _props.label,value = _props.value,type = _props.type,disabled = _props.disabled,readOnly = _props.readOnly;var _state =
      this.state,id = _state.id,checked = _state.checked,error = _state.error;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += checked ? ' isChecked' : '';
      className += error ? ' isInvalid' : '';
      var boxtype = type === 'radio' ? 'radiobox' : type;
      return (
        _react2.default.createElement('div', {
            className: 'FormField FormField--' + boxtype + ' ' + className,
            style: style },

          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className: 'FormField-control',
              checked: checked },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: this.handleChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
              _react2.default.createElement('i', { className: 'FormField-tick' },
                _react2.default.createElement(_Icon2.default, { glyph: boxtype + '-' + (checked ? 'marked' : 'blank') })),

              _react2.default.createElement('span', { className: 'FormField-value' }, label || value)),

            error && _react2.default.createElement('p', { className: 'FormField-error' }, error))));



    } }]);return FormFieldTick;}(_react.Component);FormFieldTick.propTypes = { checked: _propTypes2.default.bool, className: _propTypes2.default.string, debounce: _propTypes2.default.number, disabled: _propTypes2.default.bool, id: _propTypes2.default.string, label: _propTypes2.default.node, name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, style: _propTypes2.default.object, touched: _propTypes2.default.bool, type: _propTypes2.default.oneOf(['radio', 'checkbox']), value: _propTypes2.default.any, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func, validation: _propTypes2.default.func };FormFieldTick.defaultProps = { checked: false, className: '', debounce: 50, type: 'radio', onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {}, validation: function validation() {} };var _initialiseProps = function _initialiseProps() {var _this2 = this;this.state = { error: null, focused: false, touched: false };this.setPropsToState = function (props) {var val = props.value;_this2.setState(function (_ref2) {var touched = _ref2.touched;return _extends({ id: props.id || 'ff-tick-' + props.name + '-' + String(val).replace(/[^\w]/g, ''), checked: props.checked }, props.touched ? { touched: true } : {});}, function () {if (_this2.state.touched) {_this2.validate();}});};this.handleChange = function (ev) {var _props2 = _this2.props,type = _props2.type,value = _props2.value,disabled = _props2.disabled,readOnly = _props2.readOnly;var checked = type !== 'radio' || !_this2.state.checked ? !_this2.state.checked : true;if (disabled || readOnly) {return;}_this2.setState(_extends({ checked: checked }, _this2.validate(checked, false)));_this2.triggerOnChange(value, checked);};this.handleFocus = function (ev) {_this2.setState({ focused: true });_this2.props.onFocus(ev);};this.handleBlur = function (ev) {_this2.setState({ focused: false, touched: true });_this2.props.onBlur(ev);};this.triggerOnChange = (0, _debounce3.default)(function () {var _props3;(_props3 = _this2.props).onChange.apply(_props3, arguments); // call the fresh prop
  }, this.props.debounce);this.validate = function () {var checked = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this2.state.checked;var updateState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;var error = _this2.props.validation(checked) || null;if (updateState && error !== _this2.state.error) {_this2.setState({ error: error });}return { error: error };};};exports.default =

FormFieldTick;